﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
'v1.00
'v1.11 lm
'	Renamed "list" to "xCLV".
'	Renamed "pnl" to "pnlMoving".
'v1.10 lm
'	Added ItemMoved event.

#Event: ItemMoved(OldIndex As Int, NewIndex As Int)

Sub Class_Globals
	Private xui As XUI
	Private mCallback As Object
	Private mEventName As String
	
	Private xCLV As CustomListView
	Private PressedColor As Int
	Private Top As Int
	Private pnlMoving As B4XView
	Private ListStartY As Int
	Private dWidth, dBackground, dTextColor As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String, clv As CustomListView)
	mCallback = Callback
	mEventName = EventName
	xCLV = clv
	
	PressedColor = xCLV.PressedColor
	dTextColor = xCLV.DefaultTextColor
	dBackground = xui.Color_Transparent
	dWidth = 30dip
End Sub

'Set values for dragger width, background color and text color
'or defaults will be used - width=30dip, background color=transparetn, text color=clv default color
Public Sub SetDefaults (width As Int, backColor As Int, txtColor As Int)
	dWidth = width
	dBackground = backColor
	dTextColor = txtColor
End Sub

Public Sub RemoveDragButtons
	For i = 0 To xCLV.Size - 1
		Dim p As B4XView = xCLV.GetPanel(i)
		Dim b As Boolean = IsLastViewADragLabel(p)
		If b Then	'IsLastViewADragLabel(p) Then
			p.GetView(p.NumberOfViews - 1).RemoveViewFromParent
		End If
	Next
	xCLV.PressedColor = PressedColor
End Sub

Private Sub IsLastViewADragLabel (p As B4XView) As Boolean
	If p.NumberOfViews > 0 Then
		Dim v As B4XView = p.GetView(p.NumberOfViews - 1)
		If v Is Label And v.Tag = Null Then
			Return False
		End If
		Return v Is Label And v.Tag = xCLV
	End If
	Return False
End Sub

Public Sub AddDragButtons
	xCLV.PressedColor = xui.Color_Transparent
	Dim fnt As B4XFont = xui.CreateMaterialIcons(30)
	For i = 0 To xCLV.Size - 1
		Dim p As B4XView = xCLV.GetPanel(i)
		If IsLastViewADragLabel(p) = False Then
			Dim lbl As Label
			lbl.Initialize("")	'Drag")
			Dim xlbl As B4XView = lbl
			xlbl.Font = fnt
			xlbl.Text = Chr(0xE25D)
			xlbl.TextColor = dTextColor
			xlbl.Color = dBackground
			xlbl.SetTextAlignment("CENTER", "CENTER")
			xlbl.Tag = xCLV
			p.AddView(xlbl, p.Width - dWidth -2dip, p.Height / 2 - 15dip, dWidth, 30dip)
			Dim r As Reflector
			r.Target = lbl	
			r.SetOnTouchListener("lbl_Touch")
		End If
	Next
End Sub

Private Sub lbl_Touch(ViewTag As Object, Action As Int, X As Float, Y As Float, EventData As Object) As Boolean
	Dim lbl As B4XView = Sender
	Dim xCLV As CustomListView = lbl.Tag

	If Action = 0 Then									'ACTION_DOWN
		Dim r As Reflector
		r.Target = xCLV.sv
		r.RunMethod2("requestDisallowInterceptTouchEvent", True, "java.lang.boolean")
		pnlMoving = xCLV.GetPanel(xCLV.GetItemFromView(lbl)).Parent
		pnlMoving.GetView(0).SetColorAndBorder(xui.Color_Transparent, 3dip, 0xFF503ACD, 0)
		ListStartY = Y + lbl.Top + pnlMoving.Top
		pnlMoving.BringToFront
		Top = pnlMoving.Top
	Else If Action = 1 Then								'ACTION_UP
		Dim index As Int = xCLV.GetItemFromView(lbl)
		pnlMoving = xCLV.GetPanel(index).Parent
		Dim Offset As Int = pnlMoving.Top + pnlMoving.Height / 2
		Dim NewIndex As Int = xCLV.FindIndexFromOffset(Offset)

		Dim UnderlyingItem As CLVItem = xCLV.GetRawListItem(NewIndex)
		If Offset - UnderlyingItem.Offset > UnderlyingItem.Size / 2 Then
			NewIndex = NewIndex + 1
		End If
		
		Dim ActualItem As B4XView  = pnlMoving.GetView(0)
		ActualItem.RemoveViewFromParent
		ActualItem.SetColorAndBorder(pnlMoving.Color, 0dip, xui.Color_Black, 0)

		Dim RawItem As CLVItem = xCLV.GetRawListItem(index)
		xCLV.RemoveAt(index)
		If NewIndex > index Then 
			NewIndex = NewIndex - 1
		End If
		NewIndex = Max(0, Min(xCLV.Size, NewIndex))
		xCLV.InsertAt(NewIndex, ActualItem, RawItem.Value)
		xCLV.GetRawListItem(NewIndex).TextItem = RawItem.TextItem

		Dim FullSubName As String = mEventName & "_ItemMoved"
		If SubExists(mCallback, FullSubName) Then
			CallSubDelayed3(mCallback, FullSubName, index, NewIndex)
		End If

	Else If Action = 2 Then 							'ACTION_MOVE
		Dim index As Int = xCLV.GetItemFromView(lbl)
		If pnlMoving.Top < xCLV.sv.ScrollViewOffsetY Then
			xCLV.sv.ScrollViewOffsetY = Max(0, xCLV.sv.ScrollViewOffsetY - 10dip)
		Else If xCLV.sv.ScrollViewOffsetY + xCLV.sv.Height < pnlMoving.Top + pnlMoving.Height Then
			xCLV.sv.ScrollViewOffsetY = xCLV.sv.ScrollViewOffsetY + 10dip
		End If
		Dim ListY As Int = Y + lbl.Top 	+ pnlMoving.Top
		Dim delta As Int = ListY - ListStartY
		pnlMoving.Top = Top + delta
	Else 
		Log("action " & Action)
	End If
	Return True
End Sub
